<?php

namespace Bydedi\Template;

use Bydedi\Container\ServiceProvider;
use Bydedi\Template\DependencyInjection\Compiler\RegisterTemplatePluginPass;
use Symfony\Component\DependencyInjection\Reference;

class TemplateServiceProvider extends ServiceProvider
{

    /**
     * Register the service provider.
     *
     * @return void
     */
    public function register()
    {
        $this->serviceContainer->addCompilerPass(
            new RegisterTemplatePluginPass()
        );

        $this->serviceContainer->register('template.name_parser', 'Symfony\Component\Templating\TemplateNameParser');

        $paths = $this->serviceContainer->getParameter('app.paths');
        $theme = $this->serviceContainer->getParameter('app.theme');

        $config = array(
            'template_dir' => $paths['themes'] . '/' . $theme['dir'] . '/templates',
            'compile_dir' => $paths['storage'] . '/template/' . $theme['dir'] . '/compiled',
            'cache_dir' => $paths['storage'] . '/template/' . $theme['dir'] . '/cache',
        );

        $this->serviceContainer->register('template', 'Bydedi\Template\Smarty\SmartyEngine')
            ->setArguments(array(new Reference('template.name_parser'), $config));

    }
}
